﻿; Allgemeine Prozeduren
; DK1IO 08/07

Procedure DBError(DBE$)
  If DatabaseError()
    MessageRequester(DBE$, DatabaseError())
  EndIf
EndProcedure

Procedure.s AddColumns(sSel.s, iListIcon)
  Define int1, i, str1.s, sRecSce.s
  ClearGadgetItems(iListIcon)
  For i = 25 To 0 Step -1
    RemoveGadgetColumn(iListIcon, i)
  Next
  i = 0
  DatabaseQuery(#DB, sSel)
  While NextDatabaseRow(#DB)
    str1 = GetDBString(#DB, "Titel")
    sRecSce + str1 + ", "
    int1 = GetDBLong(#DB, "Breite")
    AddGadgetColumn(iListIcon, i, str1, int1)
    Select str1
      Case "QSLe", "QSLa", "eQSL", "QSLPrt", "SWL"
        Define.LV_COLUMN lvcTemp
        lvcTemp\mask = #LVCF_FMT
        lvcTemp\fmt = #LVCFMT_CENTER
        SendMessage_(GadgetID(iListIcon), #LVM_SETCOLUMN, i, @lvcTemp)
    EndSelect
    i + 1
  Wend
  FinishDatabaseQuery(#DB)
  sRecSce = "SELECT " + Left(sRecSce, Len(sRecSce) - 2) + " FROM Tab_Log"
  ProcedureReturn sRecSce
EndProcedure

Procedure ADIF_Tab_Log(ADIF$)
  str$ = InputRequester("ADIF-Import", "Den Lognamen eingeben", "Tab_Log")
  Define i, j, k = 1, m, i$, j$, k$, str1.s, Query$, Rufz$, Dat$, Band$, Mode$, Pwr$, RSTr$, RSTs$, Name$, QTH$, Loc$, DXCC$, EigRufz$, EETPA$, MP$, ELoc$, Px$, Op$
  If Not ReadFile(#Fle_ADIF, ADIF$)
    MessageRequester("Fehler", "Die ADIF-Datei konnte nicht geöffnet werden !")
    ProcedureReturn
  EndIf
  Repeat
    str1 = ReadString(#Fle_ADIF)
  Until UCase(Right(str1, 5)) = "<EOH>"
  While Not Eof(#Fle_ADIF)
    str1 = ""
    Repeat
      str1 + ReadString(#Fle_ADIF)
    Until UCase(Right(str1, 5)) = "<EOR>"
    Debug str1
    Repeat
      i = FindString(str1, "<", k)
      j = FindString(str1, ":", i)
      If Not j : Break : EndIf
      k = FindString(str1, ">", j)
      i$ = Mid(str1, i + 1, j - i - 1)
      j$ = Mid(str1, j + 1, k - j - 1)
      k$ = Mid(str1, k + 1, Val(j$))
      Debug k$
      Select UCase(i$)
        Case "QSO_DATE_OFF"
          Dat$ = Left(k$, 4) + "-" + Mid(k$, 5, 2) + "-" + Right(k$, 2)
        Case "TIME_OFF"
          UTC$ = k$
        Case "TIME_ON"
          UTC$ = k$
        Case "CALL"
          Rufz$ = k$
        Case "BAND"
          Band$ = Left(k$, Len(k$) - 1)
        Case "MODE"
          Mode$ = k$
          If Left(k$, 3) = "PSK" : Mode$ = "B" + k$ : EndIf
        Case "TX_PWR"
          Pwr$ = k$
        Case "RST_RCVD"
          RSTr$ = k$
        Case "RST_SENT"
          RSTs$ = k$
        Case "NAME"
          Name$ = k$
        Case "QTH"
          QTH$ = k$
        Case "GRIDSQUARE"
          Loc$ = k$
        Case "DXCC"
          DXCC$ = k$
        Case "APP_Log_DK1IO_EETPA"
          EETPA$ = k$
        Case "APP_Log_DK1IO_MP"
          MP$ = k$
        Case "MY_GRIDSQUARE"
          ELoc$ = UCase(k$) 
        Case "APP_Log_DK1IO_Px"
          Px$ = k$
        Default
          Select #True
            Case Bool(DXCC$ = "")
              DXCC$ = "''"
            Case Bool(Pwr$ = "")
              Pwr$ = "'8'"
          EndSelect
      EndSelect
    ForEver
    Debug Dat$ + " " + UTC$ + " " + Rufz$ + " " + Band$ + " " + Mode$ + " " + Pwr$ + " " + RSTr$ + " " + RSTs$ + " " + Name$ + " " + QTH$ + " " + Loc$ + " " + DXCC$ + "  " + EigRufz$ + "  " + EETPA$ + "  " + MP$ + "  " + ELoc$ + "  " + Px$
    Query$ = "INSERT INTO Tab_Log (Datum, UTC, Rufzeichen, Band, Mode, Power, RSTr, RSTs, Name, QTH, Loc, DXCC, EigRufz, EETPA, MP, ELoc, Px) "
    Query$ + "VALUES('" + Dat$ + "','" + UTC$ + "','" + Rufz$ + "'," + Band$ + ",'" + Mode$ + "'," + Pwr$ + ",'" + RSTr$ + "','" + RSTs$ + "','" + Name$ + "','" 
    Query$ + QTH$ + "','" + Loc$ + "'," + DXCC$ + ",'A','" + EETPA$ + "','" + MP$ + "','" + ELoc$ + "','" + Px$ + "')"
    Debug Query$
    DatabaseUpdate(#DB, Query$)
    DBError("ADIF -> Log")
    FinishDatabaseQuery(#DB)
    k = 1
    Dat$ = "" : UTC$ = "" : Rufz$ = "" : Band$ = "" : Mode$ = "" : Pwr$ = "" : RSTr$ = "" : RSTs$ = "" : Name$ = "" : QTH$ = "" : Loc$ = "" : DXCC$ = ""
    m + 1
  Wend
  CloseFile(#Fle_ADIF)
  k = Val(GetGadgetText(#Txt_QSONr))
  SetGadgetText(#Txt_QSONr, Str(k + m))
EndProcedure

Procedure QSOB4(sRufz.s)
  Define i, j, sRecSce.s, sSel.s, str1.s
  sSel = "SELECT * FROM Tab_AddGadgetColumn WHERE Kennz = 'QSOB4' ORDER BY Col"
  j = Len(sRufz)
  i = FindString(sRufz, "/", 1)
  If i
    If i > (j - i)
      sRufz = Left(sRufz, i - 1)
    Else
      sRufz = Right(sRufz, j - i)
    EndIf
  EndIf
  sRecSce = AddColumns(sSel, #LI_QSOB4) + " WHERE Rufzeichen LIKE '%" + sRufz + "%'" 
  DatabaseQuery(#DB, "SELECT DISTINCT Name FROM Tab_Log WHERE Name <> '' AND Rufzeichen LIKE '%" + sRufz + "%'")
  DBError("QSOB4 1")
  If FirstDatabaseRow(#DB)
    SetGadgetText(#Str_Name, GetDatabaseString(#DB, 0))
  EndIf
  FinishDatabaseQuery(#DB)
  If bContBut
    sRecSce + " AND Datum >= '" + sContStart + "' AND Band = " + Str(GetGadgetData(#Txt_Band))
  EndIf
  DatabaseQuery(#DB, sRecSce)
  DBError("QSOB4 2")
  If FirstDatabaseRow(#DB)
    SetGadgetData(#LI_QSOB4, #True)
    HideGadget(#Cnt_Wf, 1)
    iRes = FillListIcon(sRecSce, #LI_QSOB4)
    iNumQSOB4 = iRes
    sDatLastQSOB4  = GetGadgetItemText(#LI_QSOB4, iRes - 1, 3)
    sBandLastQSOB4 = GetGadgetItemText(#LI_QSOB4, iRes - 1, 6)
    sModeLastQSOB4 = GetGadgetItemText(#LI_QSOB4, iRes - 1, 7)
    HideGadget(#LI_QSOB4, 0)
  EndIf
  FinishDatabaseQuery(#DB)
EndProcedure

Procedure ContAuswert(sCont.s)
  Define i, sBand.s, sMHz.s
  Define iDB1 = OpenDatabase(#PB_Any, "Log DK1IO.db3", "", "")
  DatabaseQuery(#DB, "SELECT Band FROM Tab_Log_" + sCont)
  While NextDatabaseRow(#DB)
    i + 1
    sBand = GetDBString(#DB, "Band")
    DatabaseQuery(#DB1, "SELECT MHz FROM Tab_Band_MHz WHERE Band = " + sBand)
    FirstDatabaseRow(#DB1)
    sMHz = GetDBString(#DB1, "MHz")
    sCmd = "UPDATE Tab_Log_'" + sCont + "' SET Band = '" + sMHz + "' WHERE rowid = " + Str(i)
    DatabaseUpdate(#DB, sCmd)
  Wend
  FinishDatabaseQuery(#DB1)
  FinishDatabaseQuery(#DB)
  CloseDatabase(#DB1)
EndProcedure

Procedure.s GetQuery(sLandKen.s)
  DatabaseQuery(#DB, "SELECT SQL FROM Tab_Query WHERE LandKen = '" + sLandKen + "'")
  FirstDatabaseRow(#DB)
  Define str1.s = GetDBString(#DB, "SQL")
  FinishDatabaseQuery(#DB)
  ProcedureReturn str1
EndProcedure

Procedure FillListIcon(sRecSce.s, iListIcon)
  Define i, ii, str1.s, str2.s, str3.s
  sRecSce = "SELECT * FROM (" + sRecSce + ") AS A, (SELECT Kz, Rufz AS BenRufz FROM Tab_EigRufz) AS B ON A.EigRufz = B.Kz"
  DatabaseQuery(#DB, sRecSce)
  While NextDatabaseRow(#DB)
    AddGadgetItem(iListIcon, i, "" + #LF$)
    For ii = 0 To DatabaseColumns(#DB) - 1
      str1 = GetDatabaseString(#DB, ii)
      If ii = 2
        str2 = GetDBString(#DB, "BenRufz")
        str3 = GetDBString(#DB, "MP")
        If Len(str3) : str1 = str2 + "/"  + str3 : Else : str1 = str2 : EndIf
        str3 = GetDBString(#DB, "Px")
        If Len(str3) : str1 = str3 + "/" + str1 : EndIf
      EndIf
      If ii > 0
        Select str1
          Case "0"
            str1 = Chr($A3)
          Case "1", "-1"
            str1 = Chr($53)
        EndSelect
      EndIf
      SetGadgetItemText(iListIcon, i, str1, ii)
    Next
    i + 1
  Wend
  FinishDatabaseQuery(#DB)
  ProcedureReturn i
EndProcedure

Procedure.s GetDXCC(sRufz.s)
  Define DXCC$
  Select Left(sRufz, 3)
    Case "NL-"
      DXCC$ = "263"
    Case "US-"
      DXCC$ = "288"
    Default
      Define.s sRufz1 = Left(sRufz, 1), sRufz2 = Left(sRufz, 2), sRufz3 = Left(sRufz, 3)
      Define.s sRufz4 = Left(sRufz, 4), sRufz5 = Right(sRufz3, 1), sRufz6 = Right(sRufz4, 1)
      Define.s sRecSce = "SELECT * FROM Tab_Prefix WHERE '" + sRufz2 + "' BETWEEN Px1 AND Px2 AND '" + sRufz5 + "' BETWEEN Px3 AND Px4 AND (('" + sRufz6 + "' BETWEEN Px5 AND Px6) OR ('" + sRufz6 + "' LIKE Px5))"
      DatabaseQuery(#DB, sRecSce)
      DBError("RGLF 1")
      FirstDatabaseRow(#DB)
      DXCC$ = GetDBString(#DB, "DXCC")
      FinishDatabaseQuery(#DB)
  EndSelect
  ProcedureReturn DXCC$
EndProcedure

Procedure Log_Cabr(sCont.s)
  Define int1, int2, int3, i = 1, sDat.s, str1.s, str2.s, str3.s
  OpenFile(#Fle_Allg, "C:\Users\RL\Downloads\Log.Cabr")
  DatabaseQuery(#DB, "SELECT * FROM Tab_Cabrillo_Kopf")
  While NextDatabaseRow(#DB)
    str1 = GetDBString(#DB, "Keyword")
    str1 = str1 + Space(16 - Len(str1))
    str2 = GetDBString(#DB, "Inhalt")
    Select i
      Case 1 To 4,6,8 To 12
        str1 = str1 + str2
      Case 5
        str1 = str1 + sCont
      Case 7
        str1 = str1 + Str(int1 * int3 * 10)
    EndSelect
    WriteStringN(#Fle_Allg, str1)
    i + 1
  Wend
  FinishDatabaseQuery(#DB)
  DatabaseQuery(#DB, "SELECT * FROM Tab_Log WHERE Datum > '2013-10-05'")
  While NextDatabaseRow(#DB)
    Select GetDBLong(#DB, "Band")
      Case 80
        str3 = "3582"
      Case 40
        str3 = "7042"
      Case 20
        str3 = "14072"
      Case 15
        str3 = "21072"
    EndSelect
    str3 = "QSO: " + RSet(str3, 5)  + "PM "
    str3 + GetDBString(#DB, "Datum") + " " + GetDBString(#DB, "UTC")
    str3 + " DK1IO         " + GetDBString(#DB, "RSTs") + " "
    str3 + Right(GetDBString(#DB, "Bemerkungen"), 3) + " "
    str3 + LSet(GetDBString(#DB, "Rufzeichen"), 13)
    str3 + GetDBString(#DB, "RSTr") + " " + GetDBString(#DB, "QTH")
    WriteStringN(#Fle_Allg, str3)
  Wend
  FinishDatabaseQuery(#DB)
  WriteStringN(#Fle_Allg, "END-OF-LOG:")
  CloseFile(#Fle_Allg)
EndProcedure

Procedure EPCRUDXC()
  Define.s sStartDat = "2013-10-05", sEndDat = "2013-10-06"
  Define.s sStartTime = "0400", sEndTime = "0359"
  Define.s str1, str2, str3
  DeleteFile("C:\Users\RL\Documents\CABR\DK1IO.cbr")
  If OpenFile(#Fle_Allg, "C:\Users\RL\Documents\CABR\DK1IO.cbr")
    WriteStringN(#Fle_Allg, "START-OF-LOG: 2.0")
    WriteStringN(#Fle_Allg, "CALLSIGN: DK1IO")
    WriteStringN(#Fle_Allg, "CATEGORY: SOAB")
    WriteStringN(#Fle_Allg, "CLAIMED SCORE: 0")
    WriteStringN(#Fle_Allg, "CLUB: EPC#01424")
    WriteStringN(#Fle_Allg, "EPC-RUSSIA-DX")
    WriteStringN(#Fle_Allg, "CREATED-BY: Log DK1IO")
    WriteStringN(#Fle_Allg, "NAME: Reinhard Lipkow")
    WriteStringN(#Fle_Allg, "ADDRESS: Im Eichenbleek 24")
    WriteStringN(#Fle_Allg, "ADDRESS: 31535 Neustadt")
    WriteStringN(#Fle_Allg, "ADDRESS: Germany")
    WriteStringN(#Fle_Allg, "OPERATORS: DK1IO")
    WriteStringN(#Fle_Allg, "EMAIL: dk1io@arcor.de")
    WriteStringN(#Fle_Allg, "SOAPBOX: CheckLog")
    Define.s sRecSce = "SELECT Band, Mode, Datum, UTC, Rufzeichen, Bemerkungen FROM Tab_Log "
    sRecSce + "WHERE Mode LIKE '%PSK%' AND ((Datum = '" + sStartDat + "' AND UTC >= '" + sStartTime + "')"
    sRecSce + " OR (Datum = '" + sEndDat + "' AND UTC <= '" + sEndTime + "'))"
    If DatabaseQuery(#DB, sRecSce)
      While NextDatabaseRow(#DB)
        str1 = "QSO: "
        Select GetDatabaseLong(#DB, 0)
          Case 80
            str1 + " 3580 "
          Case 40
            str1 + " 7040 "
          Case 20
            str1 + "14070 "
          Case 15
            str1 + "21070 "
          Case 10
            str1 + "28070 "
        EndSelect
        Select GetDatabaseString(#DB, 1)
          Case "BPSK31"
            str1 + "PS "
          Case "BPSK63"
            str1 + "PM "
          Case "BPSK125"
            str1 + "PO "
        EndSelect
        str2 = GetDatabaseString(#DB, 5)
        str1 + GetDatabaseString(#DB, 2) + " " + GetDatabaseString(#DB, 3) + " DK1IO " + Right(str2, 3) + " JO42 "
        str1 + LSet(GetDatabaseString(#DB, 4), 15, " ")
        str3 = Left(str2, Len(str2) - 4)
        str1 + LSet(Left(str3, Len(str3) - 4), 4, " ") + " " + UCase(Right(str3, 4))
        WriteStringN(#Fle_Allg, str1)
      Wend
    Else
      MessageRequester("Datenbankfehler", DatabaseError())
    EndIf
    WriteStringN(#Fle_Allg, "END-OF-LOG:")
    CloseFile(#Fle_Allg)
  Else
    MessageRequester("Fehler", "Die Datei konnte nicht geöffnet werden")
  EndIf
  FinishDatabaseQuery(#DB)
EndProcedure

Procedure PowerChange(iFrqChg, iUpDn)
  Define iPwrMin, sPwr.s
  SetGadgetData(#Txt_Power, GetGadgetData(#Txt_Power) + iUpDn)
  Select iUpDn
    Case 1
      If GetGadgetData(#Txt_Power) > 14 : SetGadgetData(#Txt_Power, 14): EndIf
    Case -1
      If GetGadgetData(#Txt_Power) < 1 : SetGadgetData(#Txt_Power, 1): EndIf
  EndSelect
  Define.s sRecSce
  If iFrqChg
    sRecSce = "SELECT rowid, * FROM Tab_Power WHERE Power = 25"
  Else
    sRecSce = "SELECT rowid, * FROM Tab_Power WHERE rowid = " + Str(GetGadgetData(#Txt_Power))
  EndIf
  DatabaseQuery(#DB, sRecSce)
  FirstDatabaseRow(#DB)
  If GetDBLong(#DB, "PA")
    bPA = #True
    WriteSerialPortString(#COM_PA, "^OS1;") : Delay(500)
  Else
    bPA = #False
    WriteSerialPortString(#COM_PA, "^OS0;") : Delay(500)
  EndIf
  sPwr = GetDBString(#DB, "Power")
  SetGadgetData(#Txt_Power0, Val(sPwr))
  SetGadgetText(#Txt_Power, sPwr + " W")
  SetGadgetData(#Txt_Power, GetDBLong(#DB, "rowid"))
  sPwr = GetDBString(#DB, "PowerK3")
  FinishDatabaseQuery(#DB)
  WriteSerialPortString(#COM_K3, "K22;PC" + sPwr + ";K20;K30;")
  ;SetActiveGadget(GetGadgetData(#Cnt_Log))
EndProcedure

Procedure SetFreq()
  PowerChange(#True, 0)
  Define int1 = GetGadgetData(#Txt_Band), str1.s{6}
  SetGadgetText(#Txt_Band, Str(int1) + " m")
  DatabaseQuery(#DB, "SELECT * FROM Tab_Band_Freq WHERE Band = " + Str(GetGadgetData(#Txt_Band)))
  FirstDatabaseRow(#DB)
  sFreq = GetDBString(#DB, "PSK")
  FinishDatabaseQuery(#DB)
  DatabaseUpdate(#DB, "UPDATE Tab_Start SET Freq = '" + sFreq + "'")
  ;PokeB(*TunBufTX + 4, $05)
  ;PokeB(*TunBufTX + 5, Val("$" + Mid(sFreq, 10, 2)))
  ;PokeB(*TunBufTX + 6, Val("$" + Mid(sFreq, 08, 2)))
  ;PokeB(*TunBufTX + 7, Val("$" + Mid(sFreq, 06, 2)))
  ;PokeB(*TunBufTX + 8, Val("$" + Mid(sFreq, 04, 2)))
  ;PokeB(*TunBufTX + 9, Val("$" + Mid(sFreq, 02, 2)))
  ;PokeB(*TunBufTX + 10, $FD)
  ;If hCOM_Tun
  ;  WriteSerialPortData(#COM_Tun, *TunBufTX, 11)
  ;  PurgeComm_(SerialPortID(#COM_Tun), #PURGE_RXCLEAR)
  ;  PurgeComm_(SerialPortID(#COM_Tun), #PURGE_TXCLEAR)
  ;EndIf
  WriteSerialPortString(#COM_K3, "FA" + sFreq + ";")
  WriteSerialPortString(#COM_K3, "MD2;")
  ;WriteSerialPortString(COM_K3, "IS 1250;")
  WriteSerialPortString(#COM_K3, "MN053;UP;MN255;")
EndProcedure

Procedure EntfBer()
  Define.d B1, B2, dL, L1, L2
  Define E, W
  B1 = ((Asc(Mid(Log\ELoc$, 2, 1)) - 74) * 10 + (Asc(Mid(Log\ELoc$, 4, 1)) - 48) + (Asc(Mid(Log\ELoc$, 6, 1)) - 65) / 24 + 1 / 48) / 180 * #PI
  L1 = ((Asc(Mid(Log\ELoc$, 1, 1)) - 74) * 20 + (Asc(Mid(Log\ELoc$, 3, 1)) - 48) * 2 + (Asc(Mid(Log\ELoc$, 5, 1)) - 65) / 12 + 1 / 24) / 180 * #PI
  Define.s sLoc = GetGadgetText(#Str_Loc)
  B2 = ((Asc(Mid(sLoc, 2, 1)) - 74) * 10 + (Asc(Mid(sLoc, 4, 1)) - 48) + (Asc(Mid(sLoc, 6, 1)) - 65) / 24 + 1 / 48) / 180 * #PI
  L2 = ((Asc(Mid(sLoc, 1, 1)) - 74) * 20 + (Asc(Mid(sLoc, 3, 1)) - 48) * 2 + (Asc(Mid(sLoc, 5, 1)) - 65) / 12 + 1 / 24) / 180 * #PI
  dL = L2 - L1
  E = ACos(Sin(B1) * Sin(B2) + Cos(B1) * Cos(B2) * Cos(dL)) * 6371
  W = ATan2(Cos(B1) * Sin(B2) - Sin(B1) * Cos(B2) * Cos(dL), Sin(dL) * Cos(B2)) / #PI * 180
  If W < 0 : W + 360 : EndIf
  SetGadgetText(#Txt_Entf, " " + Str(E) + " km") : SetGadgetText(#Txt_Ri, Str(W) + "°")
  SetGadgetData(#Txt_Ri, W)
  Define.s sRecSce
  sRecSce = "SELECT COUNT(*) FROM Tab_Log WHERE SUBSTR(Loc, 1, 4) = '" + Left(GetGadgetText(#Str_Loc), 4) + "'"
  DatabaseQuery(#DB, sRecSce)
  FirstDatabaseRow(#DB)
  If GetDatabaseLong(#DB, 0) = 0
    SetGadgetColor(#Str_Loc, #PB_Gadget_FrontColor, #Red)
  Else
    SetGadgetColor(#Str_Loc, #PB_Gadget_FrontColor, #Black)
  EndIf
  FinishDatabaseQuery(#DB)
EndProcedure

Procedure WriteDTG(str1.s)
  Define.s sDTG
  Define iDat = Date()
  sDTG = #LF$ + #CR$ + "   " + FormatDate("%dd-%mm-%yyyy  %hh%ii", AddDate(iDat, #PB_Date_Hour, iTimeOffset)) + #LF$ + #CR$
  WriteStringN(#Fle_Protokoll, #LF$ + #CR$ + #LF$ + #CR$ + str1 + "  " + sDTG)
EndProcedure

Procedure Reset()
  If GetGadgetText(#Txt_LfdNr) <> "Lfd. Nr."
    SetGadgetText(#Txt_LfdNr, "IOTA") : SetGadgetText(#Str_LfdNr, "")
    SetGadgetColor(#Str_LfdNr, #PB_Gadget_FrontColor, #Black)
  EndIf
  SetGadgetColor(#Txt_Land0, #PB_Gadget_FrontColor, #Black)
  SetGadgetColor(#Txt_Rufz, #PB_Gadget_FrontColor, #DBlue)
  SetGadgetColor(#Txt_Loc, #PB_Gadget_FrontColor, #DBlue)
  SetGadgetColor(#Btn_QSL, #PB_Gadget_FrontColor, #DBlue) : Log\QSLPrt = #False
  SetGadgetColor(#Btn_QRM, #PB_Gadget_FrontColor, #DBlue)
  SetGadgetColor(#Btn_QSB, #PB_Gadget_FrontColor, #DBlue)
  SetGadgetText(#Str_Rufz,"") : SetGadgetText(#Str_Via,"")
  SetGadgetText(#Str_AndRufz,"") : SetGadgetText(#Str_RSTr,"")
  SetGadgetText(#Str_RSTs,"") : SetGadgetText(#Str_Name,"")
  SetGadgetText(#Str_QTH,"")
  SetGadgetText(#Txt_Via, "Via")
  SetGadgetText(#Str_Bemerk,"") : SetGadgetText(#Str_Loc,"")
  SetGadgetText(#Txt_Entf, "") : SetGadgetText(#Txt_Ri, "")
  SetGadgetText(#Txt_Land, "") : SetGadgetText(#Str_Comment, "")
  HideGadget(#Str_Comment, 1) : HideGadget(#Str_Bemerk, 0)
  HideGadget(#LI_QSOB4, 1)
  HideGadget(#Str_Update0, 1) : HideGadget(#Str_Update1, 1)
  SetGadgetData(#Cnt_Log, #Str_Rufz)
  ClearGadgetItems(#LI_QSOB4)
  Define i
  For i = 25 To 1 Step -1
    RemoveGadgetColumn(#LI_QSOB4, i)
  Next
  iNumQSOB4 = 0 : iYL = #False
  SetGadgetData(#LI_QSOB4, #False)
  SetActiveGadget(GetGadgetData(#Cnt_Log))
  SetGadgetData(#LI_QSOB4, #False) : HideGadget(#Img_Wf, 0)
  HideGadget(#Cnt_Wf, 0) : HideGadget(#Cnt_WX, 0)
  HideGadget(#Btn_Freq, 0) : HideGadget(#Txt_IMD, 0) : HideGadget(#Txt_SMeter, 0)
  HideGadget(#Str_WXD, 0) : HideGadget(#Str_WXE, 0) : HideGadget(#Str_Temp, 0)
  WriteSerialPortString(#COM_K3, "RC;") : WriteSerialPortString(#COM_K3, "RT0;XT0;")
  bSplit = #False
  PSKCore_SetTXFrequency(iRXFreq)
EndProcedure

Procedure.s SuchenText(str2.s, sLang.s)
  Define int1, int2, int3, str1.s, str3.s, str4.s
  Repeat
    int1 = FindString(str2,"'",1)
    If int1 = 0
      Break
    EndIf
    int2 = FindString(str2,"'",int1 + 1)
    str3 = Mid(str2, int1 + 1, int2 - 1 - int1)
    Select str3
      Case "Ant"
        str4 = "Vertical"
      Case "CALL"
        str4 = GetGadgetText(#Str_Rufz)
      Case "CallRprt"
        If GetGadgetText(#Str_RSTr)
          If sLang = "" : str4 = "rapport " : Else : str4 = "report " : EndIf
        Else
          If sLang = "" : str4 = "anruf " : Else : str4 = "call " : EndIf
        EndIf
        If GetGadgetText(#Str_QTH)
          If sLang = "" : str4 + "aus " : Else : str4 + "from " : EndIf  
          str4 + GetGadgetText(#Str_QTH) + " "
        EndIf
      Case "DOK"
        If Log\DXCC = 230
          str4 = "DOK:          H61 H61"
        Else
          str4 = ""
        EndIf
      Case "DTG"
        Define iDat = AddDate(Date(), #PB_Date_Hour, iTimeOffset)
        str4 = FormatDate("%dd-%mm-%yyyy, %hh:%ii UTC", iDat)
      Case "EigCall"
        Select GetGadgetData(#Txt_Power0)
          Case 1 To 5
            str4 = sEigRufz + "/QRP"
          Default
            str4 = sEigRufz
        EndSelect
      Case "GB"
        Select Log\DXCC
          Case 227
            str4 = "au revoir "
          Case 225, 248
            str4 = "arrivederci "
          Case 269
            str4 = "do widzenia "
          Case 15, 54, 126
            str4 = "do svidanja "
          Case 21, 29, 32, 50, 70, 100, 116, 144, 148, 281
            str4 = "adios amigo " : sLang = "Span"
          Case 339
            str4 = "sayonara "
          Default
            str4 = "bye bye "
        EndSelect
      Case "HNY"
        If (yST\wMonth = 12 And yST\wDay > 26) Or (yST\wMonth = 1 And yST\wDay < 7)
          If sLang = " E"
            str4 = "Happy New Year"
          Else
            str4 = "Gesundheit im Neuen Jahr"
          EndIf
        Else
          str4 = ""
        EndIf
      Case "LfdNr"
        str4 = GetGadgetText(#Str_LfdNr)
      Case "Loc"
        str4 = Log\ELoc$
      Case "NAME"
        str4 = GetGadgetText(#Str_Name)
      Case "POWER"
        str4 = GetGadgetText(#Txt_Power)
        If Val(Left(str4, Len(str4) - 2)) > 50
          str4 = ""
        Else
          str4 = ", " + ReplaceString(str4, " ", "")
        EndIf
        If GetGadgetText(#Txt_Mode) = "CW" : str4 = ReplaceString(str4,"0","O") : EndIf
      Case "QRM/QSB"
        If GetGadgetColor(#Btn_QRM, #PB_Gadget_FrontColor) = #Red
          str4 + " QRM"
        EndIf
        If GetGadgetColor(#Btn_QSB, #PB_Gadget_FrontColor) = #Red
          str4 + " QSB"
        EndIf
      Case "QSL"
        If GetGadgetColor(#Btn_QSL, #PB_Gadget_FrontColor) = #Red
          str4 = "QSL ok via buro"
        Else
          str4 = Chr(0)
        EndIf
      Case "QTH"
        If sLang = "" : str4 = "aus " : Else : str4 = "from " : EndIf
        str4 + GetGadgetText(#Str_QTH)
      Case "RSTs"
        str1 = GetGadgetText(#Str_RSTs)
        If str1 : str4 = str1 : Else : str4 = "579" : EndIf
      Case "ToD"
        If sLang = " E"
          str4 = sTimeOfDay
        Else
          Select sTimeOfDay
            Case "morning"
              str4 = "Morgen"
            Case "afternoon"
              str4 = "Nachmittag"
            Case "evening"
              str4 = "Abend"
          EndSelect
        EndIf
      Case "WX"
        str4 = ""
        Select sLang
          Case " E"
            str1 = GetGadgetText(#Str_WXE)
            If str1 And str1 <> "WX E"
              str4 = "WX:               " + str1 + ", Temp " + GetGadgetText(#Str_Temp) + "°"
            Else
              int1 - 1
            EndIf
          Default
            str1 = GetGadgetText(#Str_WXD)
            If str1 And str1 <> "WX D"
              str4 = "WX:               " + str1 + ", Temp " + GetGadgetText(#Str_Temp) + "°"
            Else
              int1 - 1
            EndIf
        EndSelect
      Case "XMAS"
        If yST\wMonth = 12 And yST\wDay > 13 And yST\wDay < 27
          If sLang = " E"
            str4 = "Merry Christmas and a Happy New Year"
          Else
            str4 = "Frohe Weihnachten und Gesundheit im Neuen Jahr"
          EndIf
        Else
          str4 = ""
        EndIf
    EndSelect
    str2 = Left(str2, int1 - 1) + str4 + Right(str2, Len(str2) - int2)
  ForEver
  ProcedureReturn str2
EndProcedure

Procedure Uhr()
  GetSystemTime_(yST)
  SetGadgetText(#Txt_Zeit, RSet(Str(yST\wHour), 2, "0") + ":" + RSet(Str(yST\wMinute), 2, "0") + ":" + RSet(Str(yST\wSecond), 2, "0"))
  If CountGadgetItems(#Edt_PSKRXTxt) > 50
    RemoveGadgetItem(#Edt_PSKRXTxt, 0)
  EndIf
EndProcedure

Procedure SetWindow()
  Define i, iStart, str1.s{16}
  PurgeComm_(hCOM_K3, #PURGE_RXCLEAR)
  WriteSerialPortString(#COM_K3, "FA;")                                                             ; Hole Frequenz von VFO A
  iStart = ElapsedMilliseconds()
  Repeat
    i = AvailableSerialPortInput(#COM_K3)
    Select #True
      Case  Bool(i = 14)
        iStart = 0
        Break
      Case Bool((ElapsedMilliseconds() - iStart) > 100)
        MessageRequester("Fehler", "Der K3 ist nicht eingeschaltet")
        End
    EndSelect
  ForEver
  ReadSerialPortData(#COM_K3, *CommRXBuf, 14)
  Delay(50)
  str$ = Str(Val(PeekS(*CommRXBuf + 5, 2, #PB_Ascii)))
  DatabaseQuery(#DB, "SELECT Band FROM Tab_Band_Freq WHERE MHz = " + str$)                        ; Umsetzung Frequenz -> Band
  FirstDatabaseRow(#DB)
  SetGadgetData(#Txt_Band, GetDatabaseLong(#DB, 0))
  SetGadgetText(#Txt_Band, GetDatabaseString(#DB, 0) + " m")
  FinishDatabaseQuery(#DB)
  DatabaseQuery(#DB, "SELECT COUNT(*) FROM Tab_Log")
  FirstDatabaseRow(#DB)
  SetGadgetText(#Txt_QSONr, Str(GetDatabaseLong(#DB, 0) + 1))
  FinishDatabaseQuery(#DB)
  SetGadgetText(#Txt_Mode, "BPSK31")                ; Betriebsart anzeigen
  WriteSerialPortString(#COM_K3, "MN055;MP008;SWT14;")
  SetPSK() : SetFreq()
  WriteSerialPortString(#COM_K3, "AI0;")
  WriteSerialPortString(#COM_K3, "RT1;RC;")
  WriteSerialPortString(#COM_K3, "RT0;XT0;")
  HideWindow(#Wnd_Op, 0)
  WriteSerialPortString(#COM_K3, "K22;FW00003;K20;K30;")
  ;WriteSerialPortString(COM_K3, "BW0350;")
  WriteSerialPortString(#COM_K3, "K22;GT0000;K20;K30;")
  ;ShowTunerStatus(#False)
  SetActiveGadget(GetGadgetData(#Cnt_Log))
EndProcedure
  
Procedure RufzGadgLostFocus(GadgetNr)
  DBError("RGLF 0")
  Define.s sPfx, sRecSce, sRecSce1, sRecSce2, sRufz = GetGadgetText(GadgetNr), sLand, sSfx
  Define i = Len(sRufz), j, k, iK
  If i > 2
    PSKRep(sRufz)
    If FindString(sRufz, "/", 5)
      Repeat
        If Mid(sRufz, i, 1) = "/"
          Select Right(sRufz, Len(sRufz) - i)
            Case "A", "J", "M", "P", "LH", "LS", "LV", "MM", "QRP", "JOTA"
              sRufz = Left(sRufz, i - 1)
            Case "0", "1", "2", "3", "4", "5", "6", "7", "8", "9"
              
            Default
              sRufz = Right(sRufz, Len(sRufz) - i) + "/" + Left(sRufz, i - 1)
          EndSelect
        EndIf
        i - 1
      Until i = 4
    EndIf
    Define.s sRufz1 = Left(sRufz, 1), sRufz2 = Left(sRufz, 2), sRufz3 = Left(sRufz, 3)
    Define.s sRufz4 = Left(sRufz, 4), sRufz5 = Right(sRufz3, 1), sRufz6 = Right(sRufz4, 1)
    sRecSce = "SELECT * FROM Tab_Prefix WHERE '" + sRufz2 + "' BETWEEN Px1 AND Px2 AND '" + sRufz5 + "' BETWEEN Px3 AND Px4 AND (('" + sRufz6 + "' BETWEEN Px5 AND Px6) OR ('" + sRufz6 + "' LIKE Px5))"
    DatabaseQuery(#DB, sRecSce)
    DBError("RGLF 1")
    FirstDatabaseRow(#DB)
    SetGadgetText(#Txt_Land, " " + GetDBString(#DB, "Land"))
    Log\DXCC = GetDBLong(#DB, "DXCC")
    Define sKont.s = GetDBString(#DB, "Kont")
    Define.f fTimeOffset = GetDatabaseFloat(#DB, DatabaseColumnIndex(#DB, "TZ"))
    FinishDatabaseQuery(#DB)
    GetSystemTime_(yST)
    If fTimeOffset = 1
      Define iLocalTimeOffset = Hour(Date()) - yST\wHour
      If iLocalTimeOffset = 2 : fTimeOffset = 2 : EndIf
    EndIf
    Define.f fLocalTime = yST\wHour + fTimeOffset
    Select #True
      Case Bool(fLocaltime > 24)
        fLocalTime - 24
      Case Bool(fLocalTime < 0)
        fLocalTime + 24
    EndSelect
    Select fLocalTime
      Case 0.0 To 11.0
        sTimeOfDay = "morning"
      Case 12.0 To 17.0
        sTimeOfDay = "afternoon"
      Case 18.0 To 23.0
        sTimeOfDay = "evening"
    EndSelect
    If FindString(sRufz, "/", 5)
      Select Log\DXCC
        Case 15, 54, 126
          Select Right(sRufz, 1)
            Case "0", "8", "9"
              Log\DXCC = 15
            Case "2"
              Log\DXCC = 126
            Default
              Log\DXCC = 54
          EndSelect
          sRecSce1 = "DXCC = " + Str(Log\DXCC)
        Case 21, 29, 32, 281
          Select Right(sRufz, 1)
            Case "6" 
              Log\DXCC = 21
            Case "8"
              Log\DXCC = 29
            Case "9"
              Log\DXCC = 32
            Default
              Log\DXCC = 281
          EndSelect
          sRecSce1 = "DXCC = " + Str(Log\DXCC)
        Case 40, 45, 236
          Select Right(sRufz, 1)
            Case "5"
              Log\DXCC = 45
            Case "9"
              Log\DXCC = 40
            Default
              Log\DXCC = 236
          EndSelect
          sRecSce1 = "DXCC = " + Str(Log\DXCC)
        Case 390
          Select Right(sRufz, 1)
            Case "1"
              sRecSce1 = "Rf = 'TA1'"
            Default
              sRecSce1 = "Rf = 'TA2'"
          EndSelect
        Default
          iK = #True
      EndSelect
      If iK = #False
        sRecSce = "SELECT Land, Kont FROM Tab_Prefix WHERE "
        DatabaseQuery(#DB, sRecSce + sRecSce1)
        DBError("RGLF 2")
        FirstDatabaseRow(#DB)
        SetGadgetText(#Txt_Land, " " + GetDatabaseString(#DB, 0))
        sKont = GetDatabaseString(#DB, 1)
        FinishDatabaseQuery(#DB)
      EndIf
      iK = #False
    EndIf
    If Log\DXCC = 0 : MessageRequester("Fehler", "Bei der Prefixsuche ist ein Fehler aufgetreten!") : EndIf
    If Right(sRufz, 3) = "/MM" : Log\DXCC = 0 : EndIf
    sRecSce = "SELECT RowId FROM Tab_Log WHERE Mode LIKE '%PSK%' AND DXCC = " + Str(Log\DXCC)
    If DatabaseQuery(#DB, sRecSce)
      DBError("RGLF 3")
      If FirstDatabaseRow(#DB)
        SetGadgetColor(#Txt_Land, #PB_Gadget_FrontColor, #Black)
      Else
        If Log\DXCC
          SetGadgetColor(#Txt_Land, #PB_Gadget_FrontColor, #Red)
        Else
          Log\DXCC = 0 : SetGadgetColor(#Txt_Land, #PB_Gadget_FrontColor, #Black)
        EndIf
      EndIf
    EndIf
    FinishDatabaseQuery(#DB)
    If DatabaseQuery(#DB, sRecSce + " AND (Power < 6)")
      If FirstDatabaseRow(#DB)
        SetGadgetColor(#Txt_Land0, #PB_Gadget_FrontColor, #Black)
      Else
        SetGadgetColor(#Txt_Land0, #PB_Gadget_FrontColor, #Red)
      EndIf
    Else
      DBError("RGLF 4")
    EndIf
    FinishDatabaseQuery(#DB)
    If Right(sRufz, 3) = "QRP"
      If DatabaseQuery(#DB, sRecSce + " AND (Rufzeichen LIKE '%/QRP' OR Comment = 'QRP')")
        If FirstDatabaseRow(#DB)
          SetGadgetColor(#Txt_Land0, #PB_Gadget_BackColor, #CntCol)
        Else
          SetGadgetColor(#Txt_Land0, #PB_Gadget_BackColor, #LBlue)
        EndIf
      Else
        DBError("RGLF 5")
      EndIf
      FinishDatabaseQuery(#DB)
    EndIf
    sRufz1 = Left(sRufz, 3) : sPfx = sRufz1
    If Right(sRufz1, 1) > "9" Or Mid(sRufz1, 2, 1) = "/"
      sPfx = Left(sRufz1, 2)
    EndIf
    sRufz1 = sRufz : i = 0
    Repeat
      iRes = FindString(sRufz1, "/", i + 1)
      If iRes
        If iRes > 4
          sRufz1 = Left(sRufz1, iRes - 1) : sRufz = sRufz1
        Else
          sRufz1 = Right(sRufz1, Len(sRufz1) - iRes)
        EndIf
      EndIf
    Until iRes = 0
    For i = Len(sRufz1) To 1 Step -1
      If Mid(sRufz1, i, 1) >= "0" And Mid(sRufz1, i, 1) <= "9"
        Break
      EndIf
    Next
    sSfx = Right(sRufz1, Len(sRufz1) - i)
    sRecSce = "SELECT RowID FROM Tab_Log WHERE Mode LIKE '%PSK%' AND Datum > '1999-12-31' AND Band > 6 AND Rufzeichen LIKE '%" + sSfx + "%'"
    If DatabaseQuery(#DB, sRecSce)
      If FirstDatabaseRow(#DB) = #False
        SetGadgetColor(#Txt_Rufz, #PB_Gadget_FrontColor, #DGreen)
      EndIf
    Else
      DBError("RGLF 6")
    EndIf
    FinishDatabaseQuery(#DB)
    sRecSce = "SELECT * FROM Tab_EPC_Members WHERE Rufzeichen = '" + sRufz + "'"
    If DatabaseQuery(#DB, sRecSce)
      DBError("RGLF 7")
      If FirstDatabaseRow(#DB)
        Define str1.s = GetDBString(#DB, "Area")
        If Len(str1)
          sRecSce = "SELECT DISTINCT Rufzeichen FROM Tab_Log WHERE Datum > '2006-06-09' AND (Rufzeichen = '" + sRufz + "' OR Rufzeichen LIKE '" + sRufz + "/%') AND Band > 6 AND Mode LIKE '%PSK%'"
          If DatabaseQuery(#DB, sRecSce)
            DBError("RGLF 8")
            If FirstDatabaseRow(#DB)
              SetGadgetColor(#Str_Rufz, #PB_Gadget_FrontColor, #DGreen)
            Else
              sRecSce = "SELECT A.Rufzeichen FROM "
              sRecSce + "(Select Rufzeichen FROM Tab_EPC_Members WHERE Area = '" + str1 + "') AS A, "
              sRecSce + "(Select DISTINCT Rufzeichen FROM Tab_Log WHERE Datum > '2006-06-09' And Band > 6 And Mode LIKE '%PSK%') AS B "
              sRecSce + "ON B.Rufzeichen = A.Rufzeichen OR B.Rufzeichen LIKE A.Rufzeichen || '/%'"
              If DatabaseQuery(#DB, sRecSce)
                DBError("RGLF 9")
                If FirstDatabaseRow(#DB)
                  SetGadgetColor(#Str_Rufz, #PB_Gadget_FrontColor, RGB($84, $25, $7b))
                Else
                  SetGadgetColor(#Str_Rufz, #PB_Gadget_FrontColor, #Red)
                EndIf
              EndIf
              FinishDatabaseQuery(#DB)
            EndIf
            FinishDatabaseQuery(#DB)
          EndIf
        Else
          sRecSce = "SELECT DISTINCT Rufzeichen FROM Tab_Log WHERE Datum > '2006-06-09' AND Rufzeichen = '" + sRufz + "' AND Band > 6 AND Mode LIKE '%PSK%'"
          If DatabaseQuery(#DB, sRecSce)
            DBError("RGLF 10")
            If FirstDatabaseRow(#DB)
              SetGadgetColor(#Str_Rufz, #PB_Gadget_FrontColor, #DGreen)
            Else
              SetGadgetColor(#Str_Rufz, #PB_Gadget_FrontColor, #Blue)
            EndIf
          EndIf 
          FinishDatabaseQuery(#DB)
        EndIf
      Else
        SetGadgetColor(#Str_Rufz, #PB_Gadget_FrontColor, #Black) 
      EndIf
    EndIf
   FinishDatabaseQuery(#DB)
    SetGadgetData(#Cnt_Log, #Str_RSTs)
    SetActiveGadget(GetGadgetData(#Cnt_Log))
    QSOB4(sRufz)
  EndIf
EndProcedure


; IDE Options = PureBasic 5.60 (Windows - x86)
; CursorPosition = 400
; FirstLine = 367
; Folding = ----
; Executable = Log DK1IO.exe
; CPU = 1
; DisableDebugger
; IncludeVersionInfo
; VersionField0 = 3.0.0
; VersionField1 = 3.0.0
; VersionField3 = Log DK1IO
; VersionField4 = 3.1.0
; VersionField5 = 3.1.0
; VersionField6 = Include-Datei mit allgemein verwendeten Prozeduren
; VersionField8 = LogGenProc.pbi
; VersionField13 = dk1io@arcor.de
; EnableUnicode