EnableExplicit

Procedure GetDTG()
  Define iDat = AddDate(Date(), #PB_Date_Hour, iTimeOffset)
  Log\Dat_ADIF$ = FormatDate("%yyyy%mm%dd", iDat)
  Log\Dat_Log$ = FormatDate("%yyyy-%mm-%dd", iDat)
  Log\UTC$ = FormatDate("%hh%ii", iDat)
EndProcedure

Procedure Log_eQSL(k)
  Define i, j, k, m
  Define.s str1, str2, sPW
  DatabaseQuery(#DB_eQSL, "SELECT Passwort FROM Tab_PW WHERE fr = 'eQSL'")
  FirstDatabaseRow(#DB_eQSL)
  sPW = GetDatabaseString(#DB_eQSL, 0)
  FinishDatabaseQuery(#DB_eQSL)
  For m = 0 To k
    str2 = "<ADIF_VER:5>2.2.7"
    str2 + "<EQSL_USER:5>DK1IO"                                                                          
    str2 + "<EQSL_PSWD:" + Str(Len(sPW)) + ">" + sPW                                                                      
    str2 + "<PROGRAMID:9>Log_DK1IO"
    str2 + "<EOH>"
    str2 + "<CALL:" + Str(Len(Log\Rufz$[m])) + ">" + Log\Rufz$[m]
    str2 + "<QSO_DATE:8>" + Log\Dat_ADIF$
    str2 + "<TIME_ON:4>" + Log\UTC$
    str2 + "<BAND:" + Str(Len(Log\Band$)) + ">" + Log\Band$
    If Mid(Log\Mode$, 2, 3) = "PSK"
      Log\Mode$ = Right(Log\Mode$, Len(Log\Mode$) - 1)
    EndIf
    str2 + "<MODE:" + Str(Len(Log\Mode$)) + ">" + Log\Mode$
    str2 + "<RST_SENT:" + Str(Len(Log\RSTs$)) + ">" + Log\RSTs$
    str1 = " W, Vert, tnx QSO, 73"
    str2 + "<QSLMSG:" + Str(Len(Log\Pwr$ + str1)) + ">" + Log\Pwr$ + str1
    str2 + "<EOR>"
    str2 = ReplaceString(str2, "<", "%3C")
    str2 = ReplaceString(str2, ">", "%3E")
    str1 = "http://www.eqsl.cc/qslcard/ImportADIF.cfm?ADIFdata=upload%20" + str2
    i = InternetOpen_("InetURL/1.0", 0, #Null, #Null, 0)
    If i
      j = InternetOpenUrl_(i, str1, #Null, 0, $80000000, 0)
      If j
        ;Define Buf$ = Space(256), int3
        ;InternetReadFile_(j, @Buf$, 256, @int3)
        ;MessageRequester("eQSL-Upload", PeekS(@Buf$, 256, #PB_Ascii))
        InternetCloseHandle_(j)
        InternetCloseHandle_(i)
        DatabaseUpdate(#DB, "UPDATE Tab_Log SET eQSL = 1 WHERE RowID = '" + Str(Val(Log\QSONr$) + m) + "'")
      EndIf
    EndIf
  Next
  FinishDatabaseQuery(#DB)
EndProcedure

Procedure LogQSO()
  Define i, j : Define.s str1
  Log\Rufz$[0] = GetGadgetText(#Str_Rufz)
  Log\Rufz$[1] = GetGadgetText(#Str_AndRufz)
  If Log\Rufz$[0] <> ""
    SetGadgetColor(#Btn_Log, #PB_Gadget_FrontColor, #Red)
    If Log\Rufz$[1] <> "" And Mid(Log\Rufz$[1], 3, 1) <> "." : j = 1 : Else : j = 0 : EndIf
    Define sDat.s, sTim.s, iDat, iTim
    DatabaseQuery(#DB, "SELECT Kz FROM Tab_EigRufz WHERE Rufz = '" + sEigRufz + "'")
    FirstDatabaseRow(#DB)
    Define ERKz$ = GetDatabaseString(#DB, 0)
    FinishDatabaseQuery(#DB)
    GetDTG()
    Select GetGadgetText(#Txt_LfdNr)
      Case "IOTA"
        Log\IOTA$ = GetGadgetText(#Str_LfdNr)
      Case "SOTA"
        Log\SOTA$ = GetGadgetText(#Str_LfdNr)
    EndSelect
    If GetGadgetData(#Txt_LfdNr)
      SetGadgetText(#Str_Bemerk, GetGadgetText(#Str_Bemerk) + " " + GetGadgetText(#Str_LfdNr))
    EndIf
    With Log
      \Band$ = Str(GetGadgetData(#Txt_Band))
      \Mode$ = GetGadgetText(#Txt_Mode)
      \Pwr$ = Str(GetGadgetData(#Txt_Power0))
      \RSTr$ = GetGadgetText(#Str_RSTr)
      \RSTs$ = GetGadgetText(#Str_RSTs)
      \Name$ = GetGadgetText(#Str_Name)
      \QTH$ = GetGadgetText(#Str_QTH)
      \Loc$ = GetGadgetText(#Str_Loc)
      \Bemerk$ = GetGadgetText(#Str_Bemerk)
      \Comment$ = GetGadgetText(#Str_Comment)
      \QSONr$ = GetGadgetText(#Txt_QSONr)
    EndWith
    For i = 0 To j
      str1 = "INSERT INTO Tab_Log (Datum, UTC, Rufzeichen, EigRufz, Band, Mode, Power, RSTs, RSTr, Name, QTH, IOTA, SOTA, Loc, ELoc, Bemerkungen, Comment, QSLa, DXCC, QSLPrt) "
      str1 + "VALUES('" + Log\Dat_Log$ + "','" + Log\UTC$ + "','" + Log\Rufz$[i] + "','" + ERKz$ + "'," + Log\Band$ + ",'" + Log\Mode$ 
      str1 + "'," + Log\Pwr$ + ",'" + Log\RSTs$ + "','" + Log\RSTr$ + "','" + Log\Name$ + "','" + Log\QTH$ + "','" + Log\IOTA$  
      str1 + "','" + Log\SOTA$ + "','" + Log\Loc$ + "','" + Log\ELoc$ + "','" + Log\Bemerk$ + "','" + Log\Comment$
      str1 + "'," + Str(Log\QSLPrt) + "," + Str(Log\DXCC) + "," + Str(Log\QSLPrt) + ")"
      DatabaseUpdate(#DB, str1)
      If DatabaseError()
        MessageRequester("Datenbankfehler", DatabaseError())
      EndIf
      FinishDatabaseQuery(#DB)
      SetGadgetText(#Txt_QSONr, Str(Val(GetGadgetText(#Txt_QSONr)) + 1))
    Next
    Log\Band$ + "M"
    CreateThread(@Log_eQSL(), j)
    If GetGadgetText(#Txt_LfdNr) = "Lfd. Nr."
      iLfdNr = Val(GetGadgetText(#Str_LfdNr)) + 1
      SetGadgetText(#Str_LfdNr, RSet(Str(iLfdNr), 3, "0"))
      str1 = "UPDATE Tab_Start SET LfdNr = " + Str(iLfdNr)
      DatabaseUpdate(#DB, str1)
      FinishDatabaseQuery(#DB)
    EndIf
  EndIf
  WriteSerialPortString(#COM_K3, "RT0;") : WriteSerialPortString(#COM_K3, "RC;") : WriteSerialPortString(#COM_K3, "XT0;")
  AddWindowTimer(#Wnd_Op, #Tmr_Log, 500)
  SetGadgetData(#Cnt_Log, #Str_Rufz)
  SetActiveGadget(GetGadgetData(#Cnt_Log))
EndProcedure



; IDE Options = PureBasic 5.60 (Windows - x86)
; CursorPosition = 43
; FirstLine = 6
; Folding = -
; EnableXP